(setq rel "rel: 14/15 0801 hm !")
(defun c:I_profil (/	     asatz     achs	 schr	   typ_
		   typ_f     gp1       gp2	 entity	   darst
		   la_prof   blk       la_unsi	 la_achs   la_schr
		   wink	     laen      typ_t	 ei_w	   work
		   ei_t	     ei_       efp_t	 efp_w	   efp_
		   profil_   profil    profil_i	 schr_stil schr_mst
		   color_prof	       color_unsi	   color_achs
		   color_schr	       lttyp_prof	   lttyp_unsi
		   lttyp_achs	       lttyp_schr	   file
		   init	     einh      txt	 dfile	   lfile
		   efpti0    efpti1    efpti2	 dia	   du
		   inifile
		  )
  (princ
    "\nT-Profile, (P) 8/2001 M. Hildenbrand / A.Schindler"
  )
  (c:ahm_f:I_profil)
)
(defun c:ahm_f:I_profil	(/	   asatz     achs      schr
			 typ_	   typ_f     gp1       gp2
			 entity	   darst     la_prof   blk
			 la_unsi   la_achs   la_schr   wink
			 laen	   typ_t     ei_w      work
			 ei_t	   ei_	     efp_t     efp_w
			 efp_	   profil_   profil    profil_i
			 schr_stil schr_mst  color_prof
			 color_unsi	     color_achs
			 color_schr	     lttyp_prof
			 lttyp_unsi	     lttyp_achs
			 lttyp_schr	     file      init
			 einh	   txt	     dfile     lfile
			 efpti0	   efpti1    efpti2    dia
			 du	   inifile
			)
  (if
    (findfile "I_profil.ini")
     (progn
       (setq inifile
	      (open
		(findfile "I_profil.ini")
		"r"
	      )
       )
       (setq ei_
	      (read-line inifile)
       )
       (setq efp_
	      (read-line inifile)
       )
       (setq achs
	      (read-line inifile)
       )
       (setq schr
	      (read-line inifile)
       )
       (setq schr_stil
	      (read-line inifile)
       )
       (setq schr_mst
	      (read-line inifile)
       )
       (setq profil_
	      (read-line inifile)
       )
       (setq typ_
	      (read-line inifile)
       )
       (setq darst
	      (read-line inifile)
       )
       (setq entity
	      (read-line inifile)
       )
       (close inifile)
     )
     (progn
       (alert "INI-Datei befindet sich nicht im Support-Pfad!")
     )
  )
  (if (not init)
    (if	(setq file (findfile "Einheit.ini"))
      (load file)
      (progn (alert (nth 0 txt)) (exit))
    )
  )
  (setq dfile "I_profil.ger")
  (if (setq file (findfile dfile))
    (progn
      (prompt (strcat "\nLade " dfile "."))
      (load dfile)
      (prompt "ok.")
    )
  )
  (prompt
    (strcat "\nI_profil " rel)
  )
  (error_s
    (list "angdir"	"blipmode"    "cmdecho"	    "osmode"
	  "thickness"	"clayer"      "hpname"	    "hpscale"
	 )
  )

  (if (not (setq file (findfile "I_profil.dat")))
    (progn (alert (nth 1 txt)) (exit))
  )
  (ahm_f:I_profil_dcl)
  (if work
    (ahm_f:I_profil_work Profil)
  )
  (if
    (findfile "I_profil.ini")
     (progn
       (setq inifile
	      (open
		(findfile "I_profil.ini")
		"w"
	      )
       )
       (write-line ei_ inifile)
       (write-line efp_ inifile)
       (write-line achs inifile)
       (write-line schr inifile)
       (write-line schr_stil inifile)
       (write-line schr_mst inifile)
       (write-line profil_ inifile)
       (write-line typ_ inifile)
       (write-line darst inifile)
       (write-line entity inifile)
       (close inifile)
     )
     (progn
       (alert "INI-Datei befindet sich nicht im Support-Pfad!")
     )
  )
  (error_r)
  (princ)
)
(defun ahm_f:I_profil_dcl (/ line fr du ldiag done lae char word liste)
  (if (not (setq lfile (findfile "I_profil.dcl")))
    (alert (strcat (nth 2 txt)))
  )
  (if (not la_prof)
    (progn (setq la_prof "Profil")
	   (setq color_prof "7")
	   (setq lttyp_prof "continuous")
	   (command "layer"   "m"	la_prof	  "fa"	    color_prof
		    ""	      "L"	lttyp_prof	    la_prof
		    ""
		   )
    )
  )
  (if (not la_unsi)
    (progn (setq la_unsi "Profil_Unsicht")
	   (setq color_unsi "6")
	   (setq lttyp_unsi "verdeckt")
	   (command "layer"   "m"	la_unsi	  "fa"	    color_unsi
		    ""	      "L"	lttyp_unsi	    la_unsi
		    ""
		   )
    )
  )
  (if (not la_achs)
    (progn (setq la_achs "Profil_Achsen")
	   (setq color_achs "4")
	   (setq lttyp_achs "mitte")
	   (command "layer"   "m"	la_achs	  "fa"	    color_achs
		    ""	      "L"	lttyp_achs	    la_achs
		    ""
		   )
    )
  )
  (if (not la_schr)
    (progn (setq la_schr "Profil_Schraff")
	   (setq color_schr "1")
	   (setq lttyp_schr "continuous")
	   (command "layer"   "m"	la_schr	  "fa"	    color_schr
		    ""	      "L"	lttyp_schr	    la_schr
		    ""
		   )
    )
  )
  (if (not entity)
    (setq entity "0")
  )
  (if (not darst)
    (setq darst "vorne")
  )
  (if (not achs)
    (setq achs "0")
  )
  (if (not schr)
    (setq schr "0")
  )
  (if (not blk)
    (setq blk "1")
  )
  (if (not schr_stil)
    (setq schr_stil "ansi31")
  )
  (if (not schr_mst)
    (setq schr_mst "1.5")
  )
  (setq	fr    (open file "r")
	typ_f nil
	typ_t nil
  )
  (while (setq line (read-line fr))
    (setq typ_f	(cons (substr line 1 12) typ_f)
	  typ_t	(cons (substr line 13) typ_t)
    )
  )					
  (close fr)
  (setq	typ_f (reverse typ_f)		
	typ_t (reverse typ_t)		
  )
  (if
    (not typ_)
     (setq typ_ "0")
  )			
  (setq	ei_t nil
	ei_w nil
  )
  (foreach du einh
    (setq ei_t (cons (car du) ei_t)	
	  ei_w (cons (caddr du) ei_w)	
    )
  )
  (setq	ei_t (reverse ei_t)
	ei_w (reverse ei_w)
  )
  (defun pr_dcl_einfueg_i (/ du da)
  (setq	efp_t nil
	efp_w nil
  )
  (cond
    ((= darst "vorne") (setq da efpti0))
    ((= darst "seite") (setq da efpti1))
    ((= darst "drauf") (setq da efpti2))
    ('T (setq da "T"))
  )
(foreach du da
      (setq efp_t (cons (car du) efp_t)	
	  efp_w	  (cons (cadr du) efp_w)	
    )
   )
  (setq	efp_t (reverse efp_t)
	efp_w (reverse efp_w)
  )
  (if (not efp_)
    (setq efp_ "0")
  )
  (start_list "einfpkti")
  (mapcar 'add_list efp_t)
  (end_list)
  (set_tile "einfpkti" efp_)
 )
  (setq ld "I_profil_ger")
  (setq ldiag (load_dialog lfile))
  (if ldiag
    (if	(not (new_dialog ld ldiag))
      (exit)
    )
    (exit)
  )
  (start_list "typ")
  (mapcar 'add_list typ_t)
  (end_list)
  (set_tile "typ" typ_)
  (pr_dcl_typ_i typ_)
  (start_list "einheit")
  (mapcar 'add_list ei_t)
  (end_list)
  (if (not ei_)
    (cond
      ((= ahm_v:emst 0.001) (setq ei_ "0"))
      ((= ahm_v:emst 0.01) (setq ei_ "1"))
      ((= ahm_v:emst 1.0) (setq ei_ "2"))
      ('T (setq ei_ "0"))
    )					
  )					
  (set_tile "einheit" ei_)
  (set_tile "entity" entity)
  (set_tile "darst" darst)
  (set_tile "schraffstil" schr_stil)
  (set_tile "schraffmst" schr_mst)
  (set_tile "achsen" achs)
  (set_tile "schraff" schr)
  (set_tile "block" blk)
  (pr_dcl_dia_i)
  (pr_dcl_einfueg_i)
  (action_tile "einheit" "(setq ei_    $VALUE)")
  (action_tile "einfpkti" "(setq efp_    $VALUE)")
  (action_tile "entity" "(pr_dcl_entity_i  $VALUE)")
  (action_tile "darst" "(pr_dcl_darst_i   $VALUE)")
  (action_tile "achsen" "(setq achs   $VALUE)")
  (action_tile "schraff" "(pr_dcl_schr_i    $VALUE)")
  (action_tile "block" "(setq blk    $VALUE)")
  (action_tile "typ" "(pr_dcl_typ_i      $VALUE)")
  (action_tile "Profile" "(setq Profil_ $VALUE)")
  (action_tile "schraffstil" "(setq schr_stil   $VALUE)")
  (action_tile "schraffmst" "(setq schr_mst   $VALUE)")
  (action_tile "chancel" "(done_dialog 0)")
  (action_tile "accept" "(done_dialog 1)")
  (setq done (start_dialog))
  (unload_dialog ldiag)
  (cond
    ((= done 1)
     (setq ei_t	     (strcase (nth (atoi ei_) ei_t) nil)
	   ei_w	     (nth (atoi ei_) ei_w) 
	   efp_t     (strcase (nth (atoi efp_) efp_t) nil)
	   efp_w     (nth (atoi efp_) efp_w) 
	   Profil    (nth (atoi Profil_) Profil)
	   word:list nil
	   schr_stil (strcase schr_stil)
     )
     (setq lae	 (strlen Profil)
	   word	 ""
	   liste nil
     )
     (repeat (+ lae 1)
       (setq char   (substr Profil 1 1)
	     Profil (substr Profil 2)
       )
       (if (and (/= char " ") (/= char ""))
	 (setq word (strcat word char))
	 (if (/= word "")
	   (setq liste (cons word liste)
		 word  ""
	   )
	 )
       )
     )					
     (setq Profil (reverse liste)
	   work	  T
     )
    )					
    ((= done 0)
     (princ (strcat "\n" (nth 10 txt)))
     (setq work nil)
    )					
  )
  (princ)
)					
(defun pr_dcl_typ_i (wert / file fr du)
  (setq file (findfile (setq du (nth (atoi wert) typ_f))))
  (if (not file)
    (progn
      (alert (strcat "AHM_FEHLER: Kann " du " nicht finden."))
      (set_tile "typ" typ_)
    )
    (progn
      (setq fr
	     (open file "r")
	    Profil_i nil
      )
      (while
	(setq line
	       (read-line fr)
	)
	 (setq line
		(substr line 1 8)
	 )
	 (setq lae
		(strlen line)
	       word ""
	 )
	 (repeat
	   (+ lae 1)
	    (setq char
		       (substr line 1 1)
		  line
		       (substr line 2)
	    )
	    (if
	      (and
		(/= char " ")
		(/= char "")
	      )
	       (progn
		 (if
		   (= char "_")
		    (setq char "/")
		 )
		 (setq word
			(strcat word char)
		 )
	       )
	    )
	 )
	 (setq line word)
	 (setq Profil_i
		(cons line Profil_i)
	 )
      )
      (setq Profil_i
	     (reverse Profil_i)
      )
      (close fr)
      (setq fr	   (open file "r")
	    Profil nil
      )
      (setq dia (substr du 10 3))
      (pr_dcl_dia_i)
      (while (setq line (read-line fr))
	(setq Profil (cons line Profil))
      )
      (setq Profil  (reverse Profil)
	    du	    (- (length Profil) 1)
	    Profil_ (if	(not Profil_)
		      "0"
		      Profil_
		    )
	    Profil_ (if	(> (atoi Profil_) du)
		      (itoa du)
		      Profil_
		    )
	    typ_    wert
      )
      (close fr)
      (start_list "Profile")
      (mapcar 'add_list Profil_i)
      (end_list)
      (set_tile "Profile" Profil_)
    )
  )
)
(defun pr_dcl_dia_i (/ x y dux)

  (cond
    ((= darst "vorne") (setq dux "0"))
    ((= darst "seite") (setq dux "1"))
    ((= darst "drauf") (setq dux "2"))
    ('T (setq dux "T"))
  )
  (setq	x (dimx_tile "slide")
	y (dimy_tile "slide")
  )
  (start_image "slide")
  (fill_image 0 0 x y 0)
  (slide_image 0 0 x y (strcat "I_profil(" dia dux ")"))
  (end_image)

)
(defun pr_dcl_schr_i (wert)
  (if
    (or
      (or
	(= darst "seite")
	(= darst "drauf")
      )
      (and
	(= entity "1")
	(= darst "vorne")
      )
    )
     (set_tile "schraff"
	       (setq schr "0")
     )
  )
  (setq schr wert)
)
(defun pr_dcl_darst_i (wert)
  (if (or (= wert "seite") (= wert "drauf"))
    (progn
      (set_tile "entity" (setq entity "0"))
      (set_tile "schraff" (setq schr "0"))
    )
  )
  (if (= entity "1")
    (set_tile "darst" (setq darst "vorne"))
    (set_tile "schraff"
	      (setq schr "0")
    )
  )
  (setq darst wert)
  (pr_dcl_dia_i)
  (pr_dcl_einfueg_i)
)
(defun pr_dcl_entity_i (wert)
  (if
    (or
      (= darst "drauf")
      (= darst "seite")
    )
     (progn
       (set_tile "darst"
		 (setq darst "vorne")
       )
       (set_tile "schraff"
		 (setq schr "0")
       )
     )
  )
  (if
    (= entity "1")
     (set_tile "darst"
	       (setq darst "vorne")
     )
  )
  (setq entity wert)
  (pr_dcl_dia_i)
)
(defun pr_wink_vorne ()
  (if (= entity "1")			
    (progn (initget 32)
      (setq GP1 (getpoint "\n Startpunkt:"))
      (setq GP2 (getpoint "\n Endpunkt:" GP1))
      (if (wcmatch (getvar "acadver") "*15*")
	(command "_.ucs" "_zaxis" GP1 GP2)
	(command "_.ucs" "ac" GP1 GP2)
      )
    )
  )
  (setq wink (getint "\n Einfgewinkel (Verdrehung) Eingeben <0>:"))
  (if (= wink nil)
    (setq wink 0.0)
  )
  (if (/= wink 0.0)
    (command "_.ucs" "_z" wink)
  )
)					
(defun pr_wink (/ winkel)
  (initget 32)
  (setq GP1 (getpoint "\n Startpunkt:"))
  (setq GP2 (getpoint "\n Endpunkt:" GP1))
  (setq winkel (angle GP1 GP2))
  (setq laen (distance Gp1 Gp2))
  (setq wink (/ (* winkel 180) pi))
  (if (/= wink 0.0)
    (command "_.ucs" "_z" wink)
  )
)
(defun pr_einfpkt_vorne_i	(opt ho br)
  (cond
    ((= efp_w "OL")
     (setq pts (polar pts (* 3 pih) (/ ho 2.0))
	   pts (polar pts 0 (/ br 2.0))
     )
    )
    ((= efp_w "ML") (setq pts (polar pts 0 (/ br 2.0))))
    ((= efp_w "UL")
     (setq pts (polar pts pih (/ ho 2.0))
	   pts (polar pts 0 (/ br 2.0))
     )
    )
    ((= efp_w "OM")
     (setq pts (polar pts (* 3 pih) (/ ho 2.0)))
    )
    ((= efp_w "UM") (setq pts (polar pts pih (/ ho 2.0))))
    ((= efp_w "OR")
     (setq pts (polar pts (* 3 pih) (/ ho 2.0))
	   pts (polar pts pi (/ br 2.0))
     )
    )
    ((= efp_w "MR") (setq pts (polar pts pi (/ br 2.0))))
    ((= efp_w "UR")
     (setq pts (polar pts pih (/ ho 2.0))
	   pts (polar pts pi (/ br 2.0))
     )
    )
    ((= efp_w "SW") (setq pts pts))
    ('T
     (alert
       "UNGEULTIGE OPTION EINFUEGEPUNKT:\nSchwerpunkt wird als Vorgabe verwendet."
     )
    )
  )					
)
(defun pr_einfpkt_seite	(opt ho)
  (cond
    ((= efp_w "OL")
     (setq pts (polar pts (* 3 pih) (/ ho 2.0)))
    )
    ((= efp_w "SW")
     (setq pts pts)
    )
    ((= efp_w "UL")
     (setq pts (polar pts pih (/ ho 2.0)))
    )
    ('T
     (alert
       "UNGEULTIGE OPTION EINFUEGEPUNKT:\nSchwerpunkt wird als Vorgabe verwendet."
     )
    )
  )					
)
(defun pr_einfpkt_drauf	(opt br)
  (cond
    ((= efp_w "OL")
     (setq pts (polar pts (* 3 pih) (/ br 2)))
    )
    ((= efp_w "SW")
     (setq pts pts)
    )
    ((= efp_w "UL")
     (setq pts (polar pts pih (/ br 2)))
    )
    ('T
     (alert
       "UNGEULTIGE OPTION EINFUEGEPUNKT:\nSchwerpunkt wird als Vorgabe verwendet."
     )
    )
  )					
)
(defun ahm_f:I_profil_work (wert  /	typ   typ2  typ3  pih	ho
			    br	  ts	tg    r1    r	  pts	ptm
			    pt0	  h-2c	bf    pt1   pt2	  pt3	pt4
			    pt5	  pt6	pts1  pt7   pt8	  pt9	pt10
			    pt11  pt12	pt13  pt14  pt15  pt16	pts2
			    pt17  pt18	pt19  pt20  pta1  pta2	pta3
			    pta4  lastob      P100  P101  P103	P105
			    P109  P107	P102  P104  P108  P106	alph
			    wl	  wt	tan   z	    Y1	  Y	r2
			    r21	  r22	V1    V11   V2	  V2a	V2b
			    V2c	  A1	A     V22   V22a  V22b	PL1
			    PL2	  P1	HP1a  HP1   P3	  P2	P4
			    mp2	  P5	P10   HP2a  HP2	  P8	mp4
			    P9	  P7	mp3   P6    P11	  HP3a	HP3
			    P13	  mp5	P12   P14   mp6	  P15	HP4a
			    HP4	  P18	mp8   P19   P17	  mp7	P16
			    lastob
			   )
  (cond
    (
     (= ei_ "0")
     (setq ein_h 1)
    )
    (
     (= ei_ "1")
     (setq ein_h 0.1)
    )
    (
     (= ei_ "2")
     (setq ein_h 0.001)
    )
  )
  (if (= darst "vorne")
    (pr_wink_vorne)
    (pr_wink)
  )					
  (command "_.layer" "se" la_prof "")
  (setq	typ  (strcase (substr (setq typt (car wert)) 1 1))
	typ2 (strcase (substr (setq typt (car wert)) 1 2))
	typ3 (strcase (substr (setq typt (car wert)) 1 3))
	pih  (/ pi 2.0)
  )
  (setq	entity-listi
	 (entlast)
  )
  (if
    (= entity-listi nil)
     (progn
       (entmake
	 (list
	   (cons 0 "POINT")
	   (cons 8 "0")
	   (cons 10
		 (list 0 0 0)
	   )
	 )
       )
       (setq entity-listi
	      (entlast)
       )
       (entdel
	 (entlast)
       )
     )
  )
  (while (not
	   (setq pts (getpoint (strcat "\n" (nth 9 txt) efp_t ": ")))
	 )
  )
  (setvar "angdir" 0)
  (setvar "cmdecho" 0)
  (setvar "osmode" 0)
  (setvar "blipmode" 0)    
  (cond
    ((or (= typ3 "IPE") (= typ2 "HE"))
     (setq ho (* (atof (nth 1 wert)) ei_w) 
	   br (* (atof (nth 2 wert)) ei_w) 
	   ts (* (atof (nth 3 wert)) ei_w) 
	   tg (* (atof (nth 4 wert)) ei_w) 
	   r1 (* (atof (nth 5 wert)) ei_w) 
     )
     (cond
       ((= darst "vorne")
	(pr_einfpkt_vorne_i pts ho br)
	(setq ptm  pts
	      pt0  (polar pts 0 (/ ts 2.0))
	      h-2c (- ho tg tg r1 r1)
	      bf   (- (/ br 2.0) r1 (/ ts 2.0))
	      pt1  (polar pt0 (* 3 pih) (/ h-2c 2.0))
	      pt2  (polar pt1 pih h-2c)
	      pt3  (polar pt2 pih r1)
	      pt4  (polar pt3 0 r1)
	      pt5  (polar pt4 0 bf)
	      pt6  (polar pt5 pih tg)
	      pts1 (polar pt6 pi (/ br 2.0))
	      pt7  (polar pt6 pi br)
	      pt8  (polar pt7 (* 3 pih) tg)
	      pt9  (polar pt8 0 bf)
	      pt10 (polar pt9 0 r1)
	      pt11 (polar pt10 (* 3 pih) r1)
	      pt12 (polar pt11 (* 3 pih) h-2c)
	      pt13 (polar pt12 (* 3 pih) r1)
	      pt14 (polar pt13 pi r1)
	      pt15 (polar pt14 pi bf)
	      pt16 (polar pt15 (* 3 pih) tg)
	      pts2 (polar pt16 0 (/ br 2.0))
	      pt17 (polar pt16 0 br)
	      pt18 (polar pt17 pih tg)
	      pt19 (polar pt18 pi bf)
	      pt20 (polar pt19 pi r1)
	      pta1 (polar pts pi (* br 0.5))
	      pta2 (polar pts 0 (* br 0.5))
	      pta3 (polar pts pih (* 0.5 ho))
	      pta4 (polar pts (* 3 pih) (* 0.5 ho))

	)				;setq
	(command "_.pline"	 pt1	 pt2	 "_arc"	 pt4
		 "_line" pt5	 pt6	 pt7	 pt8	 pt9
		 "_arc"	 pt11	 "_line" pt12	 "_arc"	 pt14
		 "_line" pt15	 pt16	 pt17	 pt18	 pt19
		 "_arc"	 pt1	 "_close"
		)
       )				
       ((= darst "seite")
	(pr_einfpkt_seite pts ho)
	(setq ptm  pts
	      P100 (polar pts (* 3 pih) (/ ho 2))
	      P101 (polar p100 0 laen)
	      P103 (polar p101 pih tg)
	      P105 (polar p101 pih (/ ho 2))
	      P109 (polar p101 pih ho)
	      P107 (polar p109 (* pih 3.0) tg)
	      P102 (polar p100 pih tg)
	      P104 (polar p100 pih (/ ho 2))
	      P108 (polar p100 pih ho)
	      P106 (polar p108 (* pih 3.0) tg)
	)
	(command "Plinie" P100 P101 P109 P108 "s")
	(command "Linie" P102 P103 "")
	(command "Linie" P106 P107 "")
	(if (= achs "1")
	  (command "_.layer" "se" la_achs "" "Linie" P104 P105 "")
	)
       )				
       ((= darst "drauf")
	(pr_einfpkt_drauf pts br)
	(setq ptm  pts
	      P100 (polar pts (* 3 pih) (/ br 2))
	      P101 (polar p100 0 laen)
	      P105 (polar p101 (/ pi 2) (/ br 2))
	      P103 (polar p105 (* pi 1.5) (/ ts 2))
	      P109 (polar p101 (/ pi 2) br)
	      P107 (polar p105 (/ pi 2) (/ ts 2))
	      P104 (polar p100 (/ pi 2) (/ br 2))
	      P102 (polar p104 (* pi 1.5) (/ ts 2))
	      P108 (polar p100 (/ pi 2) br)
	      P106 (polar p104 (/ pi 2) (/ ts 2))
	)
	(command "Plinie" P100 P101 P109 P108 "s")
	(command "_.layer" "se" la_unsi "")
	(command "Linie" P102 P103 "")
	(command "Linie" P106 P107 "")
	;;achsen
	(if (= achs "1")
	  (command "_.layer" "se" la_achs "" "Linie" P104 P105 "")
	)
       )				
     )
    )					
    ((= typ "I")
     (setq ho (* (atof (nth 1 wert)) ei_w) 
	   br (* (atof (nth 2 wert)) ei_w) 
	   ts (* (atof (nth 3 wert)) ei_w) 
	   tg (* (atof (nth 4 wert)) ei_w) 
	   r  (* (atof (nth 5 wert)) ei_w) 
     )
     (cond
       ((= darst "vorne")					
	(pr_einfpkt_vorne_i pts ho br)
	(setq ptm  pts
	      alph (atan (/ 14.0 100))
	      wl   (cos alph)
	      wt   (sin alph)
	      tan  (/ wt wl)
	      z	   (/ br 4)
	      Y1   (- z r)
	      Y	   (/ Y1 wl)
	      r2   (/ r wl)
	      r1   (/ ts wl)
	      r21  (* tan r)
	      r22  (* tan ts)
	      V1   (* pi 1.5)
	      V11  (/ pi 2)
	      V2   (- V1 alph)
	      V2a  (+ V11 alph)
	      V2b  (- V11 alph)
	      V2c  (+ V1 alph)
	      A1   (- z (* ts 1.5))
	      A	   (/ A1 wl)
	      V22  (- V11 alph)
	      V22a (+ V1 alph)
	      V22b (+ v11 alph)
	      PL1  (polar pts (* 3 pih) (/ ho 2))
	      PL2  (polar PL1 pi (/ br 2))
	      P1   (polar pl2 0 br)
	      HP1a (polar p1 pi (/ br 4))
	      HP1  (polar hp1a (/ pi 2) tg)
	      P3   (polar hp1 (- 0 alph) (+ Y r21))
	      mp1  (polar p3 V2 r)
	      P2   (polar mp1 0 r)
	      P4   (polar hp1 (- pi alph) (+ A r22))
	      mp2  (polar p4 V22 ts)
	      P5   (polar mp2 pi ts)
	      P10  (polar p1 (/ pi 2) ho)
	      HP2a (polar p10 pi (/ br 4))
	      HP2  (polar hp2a (* pi 1.5) tg)
	      P8   (polar hp2 (+ 0 alph) (+ Y r21))
	      mp4  (polar p8 V2a r)
	      P9   (polar mp4 0 r)
	      P7   (polar hp2 (+ pi alph) (+ A r22))
	      mp3  (polar p7 V22a ts)
	      P6   (polar mp3 pi ts)
	      P11  (polar p10 pi br)
	      HP3a (polar p11 0 (/ br 4))
	      HP3  (polar hp3a (* pi 1.5) tg)
	      P13  (polar hp3 (- pi alph) (+ Y r21))
	      mp5  (polar p13 V2b r)
	      P12  (polar mp5 pi r)
	      P14  (polar hp3 (- 0 alph) (+ A r22))
	      mp6  (polar p14 V2 ts)
	      P15  (polar mp6 0 ts)
	      HP4a (polar pl2 0 (/ br 4))
	      HP4  (polar hp4a (/ pi 2) tg)
	      P18  (polar hp4 (+ pi alph) (+ Y r21))
	      mp8  (polar p18 V2c r)
	      P19  (polar mp8 pi r)
	      P17  (polar hp4 (+ 0 alph) (+ A r22))
	      mp7  (polar p17 V22b ts)
	      P16  (polar mp7 0 ts)
	      pta1 (polar pts pi (+ (* br 0.5) 5.0))
	      pta2 (polar pts 0 (+ (* br 0.5) 5.0))
	      pta3 (polar pts pih (+ (* 0.5 ho) 5.0))
	      pta4 (polar pts (* 3 pih) (+ (* 0.5 ho) 5.0))
	)				;setq
	(command "Plinie"    pl2   P1	 P2    "K"   P3	   "LI"	 P4
		 "K"   P5    "LI"  P6	 "K"   P7    "LI"  P8	 "K"
		 P9    "LI"  P10   P11	 P12   "K"   P13   "LI"	 P14
		 "K"   P15   "LI"  P16	 "K"   P17   "LI"  P18	 "K"
		 P19   "LI"  "S"
		)
       )				
       ((= darst "seite")
	(pr_einfpkt_seite pts ho)
	(setq ptm  pts
	      P100 (polar pts (* 3 pih) (/ ho 2))
	      P101 (polar P100 0 laen)
	      P103 (polar p101 pih tg)
	      P105 (polar p101 pih (/ ho 2))
	      P109 (polar p101 pih ho)
	      P107 (polar p109 (* pih 3.0) tg)
	      P102 (polar P100 pih tg)
	      P104 (polar P100 pih (/ ho 2))
	      P108 (polar P100 pih ho)
	      P106 (polar p108 (* pih 3.0) tg)
	)
	(command "Plinie" P100 P101 P109 P108 "s")
	(command "Linie" P102 P103 "")
	(command "Linie" P106 P107 "")
	;;achsen
	(if (= achs "1")
	  (command "_.layer" "se" la_achs "" "Linie" P104 P105 "")
	)

       )				
       ((= darst "drauf")
	(pr_einfpkt_drauf pts br)
	(setq ptm  pts
	      P100 (polar pts (* 3 pih) (/ br 2))
	      P101 (polar p100 0 laen)
	      P105 (polar p101 (/ pi 2) (/ br 2))
	      P103 (polar p105 (* pi 1.5) (/ ts 2))
	      P109 (polar p101 (/ pi 2) br)
	      P107 (polar p105 (/ pi 2) (/ ts 2))
	      P104 (polar p100 (/ pi 2) (/ br 2))
	      P102 (polar p104 (* pi 1.5) (/ ts 2))
	      P108 (polar p100 (/ pi 2) br)
	      P106 (polar p104 (/ pi 2) (/ ts 2))
	)
	(command "Plinie" P100 P101 P109 P108 "s")
	(command "_.layer" "se" la_unsi "")
	(command "Linie" P102 P103 "")
	(command "Linie" P106 P107 "")
	;;achsen
	(if (= achs "1")
	  (command "_.layer" "se" la_achs "" "Linie" P104 P105 "")
	)
       )				
     )
    )					
  )					
  (setq lastob (entlast))
  (if
    (and
      (= schr "1")
      (/= entity "1")
    )
     (progn
       (command "_.layer" "se" la_schr "")
       (command "_.hatch" schr_stil schr_mst "" lastob "")
       (prompt (strcat "\n" (nth 3 txt)))
     )
  )
  (command "_.layer" "se" la_prof "")
  (if
    (= entity "1")
     (progn (setq laen (distance GP1 GP2))
	    (setvar "thickness" laen)
	    (command "_.extrude" lastob "" laen "")
	    (prompt (strcat "\n" typt " " (nth 4 txt)))
     )
  )
  (if
    (and
      (= darst "vorne")
      (= achs "1")
    )
     (progn
       (setvar "thickness" 0)
       (command "_.layer" "se" la_achs "")
       (setq asatz
	      (ssadd)
       )
       (command "_.line" pta1 pta2 "")
       (setq asatz
	      (ssadd
		(entlast)
		asatz
	      )
       )
       (command "_.line" pta3 pta4 "")
       (setq asatz
	      (ssadd
		(entlast)
		asatz
	      )
       )
       (if
	 (= entity "1")
	  (command "._copy"
		   asatz
		   ""
		   "@0,0,0"
		   (strcat "@0,0,"
			   (rtos laen 2)
		   )
	  )
       )
       (setq asatz nil)
     )
  )
  (if 
    (= blk "1")
     (progn
      
      (command "_.layer" "se" la_prof "")
      (setq du		 entity-listi
	    entity-listi (ssadd)
      )
      (while (setq du (entnext du))
	(ssadd du entity-listi)
      )					
      (if
	 (and
	   (/= gp1 nil)
	   (/= gp2 nil)
	 )
	  (setq	blname
		 (strcat "AHM-"
			 (strcase typt)
			 "-"
			 darst
			 "_"
			 (rtos
			   (*
			     (distance gp1 gp2)
			     1000
			   )
			   2
			   0
			 )
		 )
	  )
	  (setq	blname
		 (strcat "AHM-"
			 (strcase typt)
			 "-"
			 darst
			 "_0"
		 )
	  )
       )
       (if (tblsearch "block" blname)
	 (progn
	   (command "_.block" blname "_y" pts entity-listi "")
	   (prompt
	     (strcat "\nBlock " blname " " (nth 5 txt))
	   )
	 )
	 (progn
	   (command "_.block" blname pts entity-listi "")
	   (prompt (strcat "\n"
			   typt
			   " "
			   (nth 6 txt)
			   blname
			   " "
			   (nth 7 txt)
		   )
	   )
	 )
       )
       (command "_.insert" blname pts "" "" "")
     )
  )
)
(defun error (msg)
  (if (/= msg "Function cancelled")
    (prompt (strcat "\nAHM_Fehler:  " msg))
    (prompt (strcat "\nAHM_Fehler:  " (nth 8 txt)))
  )
  (setq *error* ahm_v:oerror)
  (error_r)
  (princ)
)
(defun error_s (liste)

  (setq	ahm_v:oerrl nil
	ahm_v:olay  (getvar "clayer")
	ocmd	    (getvar "cmdecho")
  )
  (setvar "cmdecho" 0)
  (command "_.undo" "_be")
  (if (tblsearch "UCS" "AHM_UCS")
    (command "_.ucs" "_del" "ahm_ucs")
  )
  (command "_.ucs" "_save" "ahm_ucs")

  (repeat (length liste)
    (setq du	      (car liste)
	  ahm_v:oerrl
		      (cons
			(list du (getvar du))
			ahm_v:oerrl
		      )
	  liste	      (cdr liste)
    )
  )
  (setq	ahm_v:oerror
	 *error*
	*error*	error
  )
)
(defun error_r (/ lis var val)

  (setvar "clayer" ahm_v:olay)
  (repeat (length ahm_v:oerrl)
    (setq lis	      (car ahm_v:oerrl)
	  var	      (car lis)
	  val	      (cadr lis)
	  ahm_v:oerrl (cdr ahm_v:oerrl)
    )
    (setvar var val)
  )
  (setq *error* ahm_v:oerror)
  (setvar "cmdecho" 0)
  (command "_.ucs" "_restore" "ahm_ucs")
  (command "_.ucs" "_del" "ahm_ucs")
  (command "_.undo" "_e")
  (setvar "cmdecho" ocmd)
  (princ)
)
(princ
  (strcat "\n"
	  "I_PROFIL.lsp geladen. Aufrufen mit I_PROFIL !"
	  "  "
	  rel
  )
)
(princ)
