(setq rel "rel: 14/15 0901 hm !")
(defun c:U_profil (/	     asatz     achs	 schr	   typ_
		   typ_f     gp1       gp2	 entity	   darst
		   la_prof   blk       la_unsi	 la_achs   la_schr
		   wink	     laen      typ_t	 ei_w	   work
		   ei_t	     ei_       efp_t	 efp_w	   efp_
		   profil_   profil    schr_stil schr_mst  color_prof
		   color_unsi	       color_achs	   color_schr
		   lttyp_prof	       lttyp_unsi	   lttyp_achs
		   lttyp_schr	       file	 init	   einh
		   txt	     dfile     lfile	 txt	   efptu0
		   efptu1    efptu2    dia	 du	   profil_u
		   inifile
		  )
  (princ
    "\nU-Profile, (P) 9/2001 M. Hildenbrand / A.Schindler"
  )
  (c:ahm_f:U_profil)
)
(defun c:ahm_f:U_profil	(/	   asatz     achs      schr
			 typ_	   typ_f     gp1       gp2
			 entity	   darst     la_prof   blk
			 la_unsi   la_achs   la_schr   wink
			 laen	   typ_t     ei_w      work
			 ei_t	   ei_	     efp_t     efp_w
			 efp_	   profil_   profil    schr_stil
			 schr_mst  color_prof	       color_unsi
			 color_achs	     color_schr
			 lttyp_prof	     lttyp_unsi
			 lttyp_achs	     lttyp_schr
			 file	   init	     einh      txt
			 dfile	   lfile     txt       efptu0
			 efptu1	   efptu2    dia       du
			 profil_u  inifile
			)
  (if
    (findfile "U_profil.ini")
     (progn
       (setq inifile
	      (open
		(findfile "U_profil.ini")
		"r"
	      )
       )
       (setq ei_
	      (read-line inifile)
       )
       (setq efp_
	      (read-line inifile)
       )
       (setq achs
	      (read-line inifile)
       )
       (setq schr
	      (read-line inifile)
       )
       (setq schr_stil
	      (read-line inifile)
       )
       (setq schr_mst
	      (read-line inifile)
       )
       (setq profil_
	      (read-line inifile)
       )
       (setq typ_
	      (read-line inifile)
       )
       (setq darst
	      (read-line inifile)
       )
       (setq entity
	      (read-line inifile)
       )
       (close inifile)
     )
     (progn
       (alert "INI-Datei befindet sich nicht im Support-Pfad!")
     )
  )
  (if (not init)
    (if	(setq file (findfile "Einheit.ini"))
      (load file)
      (progn (alert (nth 0 txt)) (exit))
    )
  )
  (setq dfile "U_profil.ger")
  (if (setq file (findfile dfile))
    (progn
      (prompt (strcat "\nLade " dfile "."))
      (load dfile)
      (prompt "ok.")
    )
  )

  (prompt
    (strcat "\nU_profil                                          "
	    rel
    )
  )
  (error_s
    (list "angdir"	"blipmode"    "cmdecho"	    "osmode"
	  "thickness"	"clayer"      "hpname"	    "hpscale"
	 )
  )
  (if (not (setq file (findfile "U_profil.dat")))
    (progn (alert (nth 1 txt)) (exit))
  )
  (ahm_f:U_profil_dcl)
  (if work
    (ahm_f:U_profil_work Profil)
  )
  (if
    (findfile "U_profil.ini")
     (progn
       (setq inifile
	      (open
		(findfile "U_profil.ini")
		"w"
	      )
       )
       (write-line ei_ inifile)
       (write-line efp_ inifile)
       (write-line achs inifile)
       (write-line schr inifile)
       (write-line schr_stil inifile)
       (write-line schr_mst inifile)
       (write-line profil_ inifile)
       (write-line typ_ inifile)
       (write-line darst inifile)
       (write-line entity inifile)
       (close inifile)
     )
     (progn
       (alert "INI-Datei befindet sich nicht im Support-Pfad!")
     )
  )
  (error_r)
  (princ)
)
(defun ahm_f:U_profil_dcl (/ line fr du ldiag done lae char word liste)
  (if (not (setq lfile (findfile "U_profil.dcl")))
    (alert (strcat (nth 2 txt)))
  )
  (if (not la_prof)
    (progn (setq la_prof "Profil")
	   (setq color_prof "7")
	   (setq lttyp_prof "continuous")
	   (command "layer"   "m"	la_prof	  "fa"	    color_prof
		    ""	      "L"	lttyp_prof	    la_prof
		    ""
		   )
    )
  )
  (if (not la_unsi)
    (progn (setq la_unsi "Profil_Unsicht")
	   (setq color_unsi "6")
	   (setq lttyp_unsi "verdeckt")
	   (command "layer"   "m"	la_unsi	  "fa"	    color_unsi
		    ""	      "L"	lttyp_unsi	    la_unsi
		    ""
		   )
    )
  )
  (if (not la_achs)
    (progn (setq la_achs "Profil_Achsen")
	   (setq color_achs "4")
	   (setq lttyp_achs "mitte")
	   (command "layer"   "m"	la_achs	  "fa"	    color_achs
		    ""	      "L"	lttyp_achs	    la_achs
		    ""
		   )
    )
  )
  (if (not la_schr)
    (progn (setq la_schr "Profil_Schraff")
	   (setq color_schr "1")
	   (setq lttyp_schr "continuous")
	   (command "layer"   "m"	la_schr	  "fa"	    color_schr
		    ""	      "L"	lttyp_schr	    la_schr
		    ""
		   )
    )
  )
  (if (not entity)
    (setq entity "0")
  )
  (if (not darst)
    (setq darst "vorne")
  )
  (if (not achs)
    (setq achs "0")
  )
  (if (not schr)
    (setq schr "0")
  )
  (if (not blk)
    (setq blk "1")
  )
  (if (not schr_stil)
    (setq schr_stil "ansi31")
  )
  (if (not schr_mst)
    (setq schr_mst "1.5")
  )
  (setq	fr    (open file "r")
	typ_f nil
	typ_t nil
  )
  (while (setq line (read-line fr))
    (setq typ_f	(cons (substr line 1 12) typ_f)
	  typ_t	(cons (substr line 13) typ_t)
    )
  )
  (close fr)
  (setq	typ_f (reverse typ_f)
	typ_t (reverse typ_t)
  )
  (if
    (not typ_)
     (setq typ_ "0")
  )
  (setq	ei_t nil
	ei_w nil
  )
  (foreach du einh
    (setq ei_t (cons (car du) ei_t)
	  ei_w (cons (caddr du) ei_w)
    )
  )
  (setq	ei_t (reverse ei_t)
	ei_w (reverse ei_w)
  )
  (setq	efp_t nil
	efp_w nil
  )
  (defun pr_dcl_einfueg_u (/ du da)
    (setq efp_t	nil
	  efp_w	nil
    )
    (cond
      ((= darst "vorne") (setq da efptu0))
      ((= darst "seite") (setq da efptu1))
      ((= darst "drauf") (setq da efptu2))
      ('T (setq da "T"))
    )
    (foreach du	da
      (setq efp_t (cons (car du) efp_t)
	    efp_w (cons (cadr du) efp_w)
      )
    )
    (setq efp_t	(reverse efp_t)
	  efp_w	(reverse efp_w)
    )
    (if	(not efp_)
      (setq efp_ "0")
    )
    (start_list "einfpktu")
    (mapcar 'add_list efp_t)
    (end_list)
    (set_tile "einfpktu" efp_)
  )
  (setq ld "U_profil_ger")
  (setq ldiag (load_dialog lfile))
  (if ldiag
    (if	(not (new_dialog ld ldiag))
      (exit)
    )
    (exit)
  )
  (start_list "typ")
  (mapcar 'add_list typ_t)
  (end_list)
  (set_tile "typ" typ_)
  (pr_dcl_typ_u typ_)

  (start_list "einheit")
  (mapcar 'add_list ei_t)
  (end_list)
  (if (not ei_)
    (cond
      ((= ahm_v:emst 0.001) (setq ei_ "0"))
      ((= ahm_v:emst 0.01) (setq ei_ "1"))
      ((= ahm_v:emst 1.0) (setq ei_ "2"))
      ('T (setq ei_ "0"))
    )
  )
  (set_tile "einheit" ei_)
  (set_tile "entity" entity)
  (set_tile "darst" darst)
  (set_tile "schraffstil" schr_stil)
  (set_tile "schraffmst" schr_mst)
  (set_tile "achsen" achs)
  (set_tile "schraff" schr)
  (set_tile "block" blk)
  (pr_dcl_dia_u)
  (pr_dcl_einfueg_u)
  (action_tile "einheit" "(setq ei_    $VALUE)")
  (action_tile "einfpktu" "(setq efp_    $VALUE)")
  (action_tile "entity" "(pr_dcl_entity_u  $VALUE)")
  (action_tile "darst" "(pr_dcl_darst_u   $VALUE)")
  (action_tile "achsen" "(pr_dcl_achs_u   $VALUE)")
  (action_tile "schraff" "(pr_dcl_schr_u    $VALUE)")
  (action_tile "block" "(setq blk    $VALUE)")
  (action_tile "typ" "(pr_dcl_typ_u      $VALUE)")
  (action_tile "Profile" "(setq Profil_ $VALUE)")
  (action_tile "schraffstil" "(setq schr_stil   $VALUE)")
  (action_tile "schraffmst" "(setq schr_mst   $VALUE)")
  (action_tile "chancel" "(done_dialog 0)")
  (action_tile "accept" "(done_dialog 1)")
  (setq done (start_dialog))
  (unload_dialog ldiag)
  (cond
    ((= done 1)
     (setq ei_t	     (strcase (nth (atoi ei_) ei_t) nil)
	   ei_w	     (nth (atoi ei_) ei_w)
	   efp_t     (strcase (nth (atoi efp_) efp_t) nil)
	   efp_w     (nth (atoi efp_) efp_w)
	   Profil    (nth (atoi Profil_) Profil)
	   word:list nil
	   schr_stil (strcase schr_stil)
     )
     (setq lae	 (strlen Profil)
	   word	 ""
	   liste nil
     )
     (repeat (+ lae 1)
       (setq char   (substr Profil 1 1)
	     Profil (substr Profil 2)
       )
       (if (and (/= char " ") (/= char ""))
	 (setq word (strcat word char))
	 (if (/= word "")
	   (setq liste (cons word liste)
		 word  ""
	   )
	 )
       )
     )
     (setq Profil (reverse liste)
	   work	  T
     )
    )
    ((= done 0)
     (princ (strcat "\n" (nth 10 txt)))
     (setq work nil)
    )
  )
  (princ)
)
(defun pr_dcl_typ_u (wert / file fr du)
  (setq file (findfile (setq du (nth (atoi wert) typ_f))))
  (if (not file)
    (progn
      (alert (strcat "AHM_FEHLER: Kann " du " nicht finden."))
      (set_tile "typ" typ_)
    )
    (progn
      (setq fr
	     (open file "r")
	    Profil_u nil
      )
      (while
	(setq line
	       (read-line fr)
	)
	 (setq line
		(substr line 1 7)
	 )
	 (setq lae
		(strlen line)
	       word ""
	 )
	 (repeat
	   (+ lae 1)
	    (setq char
		       (substr line 1 1)
		  line
		       (substr line 2)
	    )
	    (if
	      (and
		(/= char " ")
		(/= char "")
	      )
	       (progn
		 (if
		   (= char "_")
		    (setq char ".")
		 )
		 (setq word
			(strcat word char)
		 )
	       )
	    )
	 )
	 (setq line word)
	 (setq Profil_u
		(cons line Profil_u)
	 )
      )
      (setq Profil_u
	     (reverse Profil_u)
      )
      (close fr)
      (setq fr	   (open file "r")
	    Profil nil
      )
      (setq dia (substr du 10 3))
      (pr_dcl_dia_u)
      (while (setq line (read-line fr))
	(setq Profil (cons line Profil))
      )
      (setq Profil  (reverse Profil)
	    du	    (- (length Profil) 1)
	    profil_ (if	(not Profil_)
		      "0"
		      Profil_
		    )
	    profil_ (if	(> (atoi Profil_) du)
		      (itoa du)
		      Profil_
		    )
	    typ_    wert
      )
      (close fr)
      (start_list "Profile")
      (mapcar 'add_list Profil_u)
      (end_list)
      (set_tile "Profile" Profil_)
    )
  )
)
(defun pr_dcl_dia_u (/ x y dux)
  (cond
    ((= darst "vorne") (setq dux "0"))
    ((= darst "seite") (setq dux "1"))
    ((= darst "drauf") (setq dux "2"))
    ('T (setq dux "T"))
  )
  (setq	x (dimx_tile "slide")
	y (dimy_tile "slide")
  )
  (start_image "slide")
  (fill_image 0 0 x y 0)
  (slide_image 0 0 x y (strcat "U_profil(" dia dux ")"))
  (end_image)

)
(defun pr_dcl_schr_u (wert)
  (if
    (or
      (or
	(= darst "seite")
	(= darst "drauf")
      )
      (and
	(= entity "1")
	(= darst "vorne")
      )
    )
     (set_tile "schraff"
	       (setq schr "0")
     )
  )
  (setq schr wert)
)
(defun pr_dcl_achs_u (wert)
  (if (= darst "drauf")
    (set_tile "achsen" (setq achs "0"))
  )
  (setq achs wert)
)
(defun pr_dcl_darst_u (wert)
  (if (or (= wert "seite") (= wert "drauf"))
    (progn
      (set_tile "entity" (setq entity "0"))
      (set_tile "schraff" (setq schr "0"))
    )
  )
  (if (= wert "drauf")
    (set_tile "achsen" (setq achs "0"))
  )
  (if (= entity "1")
    (set_tile "darst" (setq darst "vorne"))
    (set_tile "schraff"
	      (setq schr "0")
    )
  )
  (setq darst wert)
  (pr_dcl_dia_u)
  (pr_dcl_einfueg_u)
)
(defun pr_dcl_entity_u (wert)
  (if
    (or
      (= darst "drauf")
      (= darst "seite")
    )
     (progn
       (set_tile "darst"
		 (setq darst "vorne")
       )
       (set_tile "schraff"
		 (setq schr "0")
       )
     )
  )
  (if (= entity "1")
    (set_tile "darst" (setq darst "vorne"))
  )
  (setq entity wert)
  (pr_dcl_dia_u)
)
(defun pr_wink_vorne ()
  (if (= entity "1")
    (progn (initget 32)
	   (setq GP1 (getpoint "\n Startpunkt:"))
	   (setq GP2 (getpoint "\n Endpunkt:" GP1))
	   (if (wcmatch (getvar "acadver") "*15*")
	     (command "_.ucs" "_zaxis" GP1 GP2)
	     (command "_.ucs" "ac" GP1 GP2)
	   )
    )
  )
  (setq wink (getint "\n Einfgewinkel Eingeben <0>:"))
  (if (= wink nil)
    (setq wink 0.0)
  )
  (if (/= wink 0.0)
    (command "_.ucs" "_z" wink)
  )
)
(defun pr_wink (/ winkel)
  (initget 32)
  (setq GP1 (getpoint "\n Startpunkt:"))
  (setq GP2 (getpoint "\n Endpunkt:" GP1))
  (setq winkel (angle GP1 GP2))
  (setq laen (distance Gp1 Gp2))
  (setq wink (/ (* winkel 180) pi))
  (if (/= wink 0.0)
    (command "_.ucs" "_z" wink)
  )
)
(defun pr_einfpkt_vorne	(opt ho br)
  (cond
    ((= efp_w "OL")
     (setq pts (polar pts (* 3 pih) (/ ho 2.0))
	   pts (polar pts 0 (/ br 2.0))
     )
    )
    ((= efp_w "ML") (setq pts (polar pts 0 (/ br 2.0))))
    ((= efp_w "UL")
     (setq pts (polar pts pih (/ ho 2.0))
	   pts (polar pts 0 (/ br 2.0))
     )
    )
    ((= efp_w "OR")
     (setq pts (polar pts (* 3 pih) (/ ho 2.0))
	   pts (polar pts pi (/ br 2.0))
     )
    )
    ((= efp_w "UR")
     (setq pts (polar pts pih (/ ho 2.0))
	   pts (polar pts pi (/ br 2.0))
     )
    )
    ((= efp_w "SW") (setq pts pts))
    ('T
     (alert
       "UNGEULTIGE OPTION EINFUEGEPUNKT:\nSchwerpunkt wird als Vorgabe verwendet."
     )
    )
  )
)
(defun pr_einfpkt_seite	(opt ho)
  (cond
    ((= efp_w "OL")
     (setq pts (polar pts (* 3 pih) (/ ho 2.0)))
    )
    ((= efp_w "SW")
     (setq pts pts)
    )
    ((= efp_w "UL")
     (setq pts (polar pts pih (/ ho 2.0)))
    )
    ('T
     (alert
       "UNGEULTIGE OPTION EINFUEGEPUNKT:\nSchwerpunkt wird als Vorgabe verwendet."
     )
    )
  )
)
(defun pr_einfpkt_drauf	(opt br)
  (cond
    ((= efp_w "OL")
     (setq pts (polar pts (* 3 pih) (/ br 2)))
    )
    ((= efp_w "SW")
     (setq pts pts)
    )
    ((= efp_w "UL")
     (setq pts (polar pts pih (/ br 2)))
    )
    ('T
     (alert
       "UNGEULTIGE OPTION EINFUEGEPUNKT:\nSchwerpunkt wird als Vorgabe verwendet."
     )
    )
  )
)
(defun ahm_f:U_profil_work (wert   /	  typ5	 pih	ho     br
			    ts	   tg	  r1	 r2	h-2c   t1
			    ez	   ym	  pts	 ptm	pt00   pt0
			    pt1	   pt7	  pt8	 pt9	pt10   pt2
			    pt3	   pt5	  ptt1	 ptt2	Q      pt_7
			    pt_t   ptr22  pt4	 pt6	pt11   pt12
			    pt13   pt14	  pt15	 pt16	ptr2   pta1
			    pta2   pta3	  pta4	 b1	ptr1   P100
			    P101   P102	  P103	 P104	P105   P106
			    P107   P108	  P109	 alph	lastob
			    entity-listu  ein_h
			   )
  (cond
    (
     (= ei_ "0")
     (setq ein_h 1)
    )
    (
     (= ei_ "1")
     (setq ein_h 0.1)
    )
    (
     (= ei_ "2")
     (setq ein_h 0.001)
    )
  )
  (if (= darst "vorne")
    (pr_wink_vorne)
    (pr_wink)
  )
  (command "_.layer" "_se" la_prof "")
  (setq	typ5 (strcase (substr (setq typt (car wert)) 1 1))
	pih  (/ pi 2.0)
  )
  (setq	entity-listu
	 (entlast)
  )
  (if
    (= entity-listu nil)
     (progn
       (entmake
	 (list
	   (cons 0 "POINT")
	   (cons 8 "0")
	   (cons 10
		 (list 0 0 0)
	   )
	 )
       )
       (setq entity-listu
	      (entlast)
       )
       (entdel
	 (entlast)
       )
     )
  )
  (while (not
	   (setq pts (getpoint (strcat "\n" (nth 9 txt) efp_t ": ")))
	 )
  )
  (setvar "angdir" 0)
  (setvar "cmdecho" 0)
  (setvar "osmode" 0)
  (setvar "blipmode" 0)
  (cond
    ((= typ5 "U")
     (setq ho	(* (atof (nth 1 wert)) ei_w)
	   br	(* (atof (nth 2 wert)) ei_w)
	   ts	(* (atof (nth 3 wert)) ei_w)
	   tg	(* (atof (nth 4 wert)) ei_w)
	   r1	(* (atof (nth 5 wert)) ei_w)
	   r2	(* (atof (nth 6 wert)) ei_w)
	   h-2c	(* (atof (nth 7 wert)) ei_w)
	   t1	(* (atof (nth 8 wert)) ei_w)
	   ez	(* (atof (nth 9 wert)) ei_w)
	   ym	(* (atof (nth 10 wert)) ei_w)
     )
     (if (<= ho 300)
       (setq b1	  (/ br 2.0)
	     alph (atan (/ 8.0 100.0))
       )
       (setq b1	  (/ (- br ts) 2.0)
	     alph (atan (/ 5.0 100.0))
       )
     )
     (cond
       ((= darst "vorne")
	(pr_einfpkt_vorne pts ho br)
	(cond
	  ((= efp_w "SM") (setq pts (polar pts 0 ym)))
	  ((= efp_w "SW") (setq pts pts))
	  ('T
	   (setq pts (polar pts pi (- (/ br 2.0) ez)))
	  )
	)
	(setq pt00  (polar pts pi ez)
	      pt0   (polar pt00 0 ts)
	      ptm   (polar pts pi ym)
	      pt1   (polar pt0 pih (/ h-2c 2.0))
	      pt16  (polar pt0 (* 3 pih) (/ h-2c 2.0))
	      pt8   (polar pt00 pih (/ ho 2.0))
	      pt9   (polar pt00 (* 3 pih) (/ ho 2.0))
	      pt7   (polar pt8 0 br)
	      pt10  (polar pt9 0 br)
	      ptt1  (polar pt7 pi b1)
	      ptt2  (polar ptt1 (* 3 pih) tg)
	      pt2   (inters pt0 pt1 ptt2 (polar ptt2 alph 1) nil)
	      pt5   (inters pt2 ptt2 pt7 (polar pt7 (* 3 pih) 1) nil)
	      ptr1  (polar pt1 0 r1)
	      pt3   (polar ptr1 (+ pih alph) r1)
	      pt_7  (polar pt7 pi r2)
	      pt_t  (polar ptt2 (+ pih alph) r2)
	      ptr22 (inters pt_7
			    (polar pt_7 (* 3 pih) 1)
			    pt_t
			    (polar pt_t alph 1)
			    nil
		    )
	      pt4   (polar ptr22 (+ (* 3 pih) alph) r2)
	      pt6   (polar ptr22 0 r2)

	      ptt1  (polar pt10 pi b1)
	      ptt2  (polar ptt1 pih tg)
	      pt15  (inters pt0 pt1 ptt2 (polar ptt2 (- pi alph) 1) nil)
	      pt12  (inters pt15 ptt2 pt10 (polar pt10 pih 1) nil)
	      ptr1  (polar pt16 0 r1)
	      pt14  (polar ptr1 (- (* 3 pih) alph) r1)
	      pt_7  (polar pt10 pi r2)
	      pt_t  (polar ptt2 (- (* 3 pih) alph) r2)
	      ptr2  (inters pt_7
			    (polar pt_7 pih 1)
			    pt_t
			    (polar pt_t (- pi alph) 1)
			    nil
		    )
	      pt13  (polar ptr2 (- pih alph) r2)
	      pt11  (polar ptr2 0 r2)

	      pta1  (polar pt00 pi (* ein_h 5.0))
	      pta2  (polar pt00 0 (+ (* ein_h 5.0) br))
	      pta3  (polar pts pih (+ (* 0.5 ho) (* ein_h 5.0)))
	      pta4  (polar pts (* 3 pih) (+ (* 0.5 ho) (* ein_h 5.0)))
	)

	(command "_.pline"	   pt16	    pt1	     "_arc"   pt3
		 "_line"  pt4	   "_arc"   pt6	     "_line"  pt7
		 pt8	  pt9	   pt10	    pt11     "_arc"   pt13
		 "_line"  pt14	   "_arc"   pt16     "_close"
		)
       )
       ((= darst "seite")
	(pr_einfpkt_seite pts ho)
	(setq ptm  pts
	      P100 (polar pts (* 3 pih) (/ ho 2))
	      P101 (polar p100 0 laen)
	      P103 (polar p101 pih tg)
	      P105 (polar p101 pih (/ ho 2))
	      P109 (polar p101 pih ho)
	      P107 (polar p109 (* pih 3.0) tg)
	      P102 (polar p100 pih tg)
	      P104 (polar p100 pih (/ ho 2))
	      P108 (polar p100 pih ho)
	      P106 (polar p108 (* pih 3.0) tg)
	)
	(Initget 1 "J N")
	(setq Q (getkword "\ Flansch Sichtbar (J/N) ?"))
	(command "Plinie" P100 P101 P109 P108 "s")
	(if (= Q "N")
	  (progn
	    (command "_.layer" "_se" la_unsi "")
	    (command "Linie" P102 P103 "")
	    (command "Linie" P106 P107 "")
	  )
	)
	(command "Linie" P102 P103 "")
	(command "Linie" P106 P107 "")
	(if (= achs "1")
	  (command "_.layer" "_se" la_achs "" "Linie" P104 P105 "")
	)
       )
       ((= darst "drauf")
	(pr_einfpkt_drauf pts br)
	(setq ptm  pts
	      P100 (polar pts (* 3 pih) (/ br 2))
	      P101 (polar p100 0 laen)
	      P105 (polar p101 (/ pi 2) (/ br 2))
	      P109 (polar p101 (/ pi 2) br)
	      P107 (polar p109 (* pih 3) ts)
	      P104 (polar p100 (/ pi 2) (/ br 2))
	      P108 (polar p100 (/ pi 2) br)
	      P106 (polar p108 (* pih 3) ts)
	)
	(command "Plinie" P100 P101 P109 P108 "s")
	(command "_.layer" "_se" la_unsi "")
	(command "Linie" P106 P107 "")
	(Initget 1 "J N")
	(setq Q (getkword "\ Ist die Darstellung Richtig (J/N) ?"))
	(if (= Q "N")
	  (command "spiegeln" "L" "" P104 P105 "Ja")
	)
       )
     )
    )
  )

  (setq lastob (entlast))
  (if (and
	(= schr "1")
	(/= entity "1")
      )
    (progn
      (command "_.layer" "_se" la_schr "")
      (command "_.hatch" schr_stil schr_mst "" lastob "")
      (prompt (strcat "\n" (nth 3 txt)))
    )
  )
  (command "_.layer" "_se" la_prof "")
  (if (= entity "1")
    (progn (setq laen (distance GP1 GP2))
	   (setvar "thickness" laen)
	   (command "_.extrude" lastob "" laen "")
	   (prompt (strcat "\n" typt " " (nth 4 txt)))
    )
  )
  (if
    (and
      (= darst "vorne")
      (= achs "1")
    )
     (progn
       (setvar "thickness" 0)
       (command "_.layer" "se" la_achs "")
       (setq asatz
	      (ssadd)
       )
       (command "_.line" pta1 pta2 "")
       (setq asatz
	      (ssadd
		(entlast)
		asatz
	      )
       )
       (command "_.line" pta3 pta4 "")
       (setq asatz
	      (ssadd
		(entlast)
		asatz
	      )
       )
       (if
	 (= entity "1")
	  (command "._copy"
		   asatz
		   ""
		   "@0,0,0"
		   (strcat "@0,0,"
			   (rtos laen 2)
		   )
	  )
       )
       (setq asatz nil)
     )
  )
  (if (= blk "1")
    (progn
      (command "_.layer" "_se" la_prof "")
      (setq du		 entity-listu
	    entity-listu (ssadd)
      )
      (while (setq du (entnext du))
	(ssadd du entity-listu)
      )
      (if
	(and
	  (/= gp1 nil)
	  (/= gp2 nil)
	)
	 (setq blname
		(strcat	"AHM-"
			(strcase typt)
			"-"
			darst
			"_"
			(rtos
			  (*
			    (distance gp1 gp2)
			    1000
			  )
			  2
			  0
			)
		)
	 )
	 (setq blname
		(strcat	"AHM-"
			(strcase typt)
			"-"
			darst
			"_0"
		)
	 )
      )
      (if (tblsearch "block" blname)
	(progn
	  (command "_.block" blname "_y" pts entity-listu "")
	  (prompt
	    (strcat "\nBlock " blname " " (nth 5 txt))
	  )
	)
	(progn
	  (command "_.block" blname pts entity-listu "")
	  (prompt (strcat "\n"
			  typt
			  " "
			  (nth 6 txt)
			  blname
			  " "
			  (nth 7 txt)
		  )
	  )
	)
      )
      (command "_.insert" blname pts "" "" "")
    )
  )
)
(defun error (msg)
  (if (/= msg "Function cancelled")
    (prompt (strcat "\nAHM_FEHLER:  " msg))
    (prompt (strcat "\nAHM_FEHLER:  " (nth 8 txt)))
  )
  (setq *error* ahm_v:oerror)
  (error_r)
  (princ)
)
(defun error_s (liste)

  (setq	ahm_v:oerrl nil
	ahm_v:olay  (getvar "clayer")
	ocmd	    (getvar "cmdecho")
  )
  (setvar "cmdecho" 0)
  (command "_.undo" "_be")
  (if (tblsearch "UCS" "Ahm_UCS")
    (command "_.ucs" "_del" "ahm_ucs")
  )
  (command "_.ucs" "_save" "ahm_ucs")

  (repeat (length liste)
    (setq du	      (car liste)
	  ahm_v:oerrl
		      (cons
			(list du (getvar du))
			ahm_v:oerrl
		      )
	  liste	      (cdr liste)
    )
  )
  (setq	ahm_v:oerror
	 *error*
	*error*	error
  )

)
(defun error_r (/ lis var val)

  (setvar "clayer" ahm_v:olay)
  (repeat (length ahm_v:oerrl)
    (setq lis	      (car ahm_v:oerrl)
	  var	      (car lis)
	  val	      (cadr lis)
	  ahm_v:oerrl (cdr ahm_v:oerrl)
    )
    (setvar var val)
  )
  (setq *error* ahm_v:oerror)
  (setvar "cmdecho" 0)
  (command "_.ucs" "_restore" "ahm_ucs")
  (command "_.ucs" "_del" "ahm_ucs")
  (command "_.undo" "_e")
  (setvar "cmdecho" ocmd)
  (princ)
)
(princ
  (strcat "\n"
	  "U_PROFIL.lsp geladen. Aufrufen mit U_PROFIL !"
	  "  "
	  rel
  )
)
(princ)