(setq rel "rel: 14/15 0601 hm !")
(defun c:Hoprofil (/ asatz achs schr typ_ typ_f gp1 gp2 entity darst la_prof blk la_unsi la_achs la_schr wink laen typ_t ei_w work ei_t ei_ efp_t efp_w efp_ profil_ profil profil2 schr_stil schr_mst color_prof color_unsi color_achs color_schr lttyp_prof lttyp_unsi lttyp_achs lttyp_schr file init einh txt dfile lfile efptho0 efptho1 efptho2 dia du inifile)
  (princ "\nHohlprofile, (P) 6/2001 M. Hildenbrand / A.Schindler")
  (c:ahm_f:Hoprofil)
)
(defun c:ahm_f:Hoprofil  (/ asatz achs schr typ_ typ_f gp1 gp2 entity darst la_prof blk la_unsi la_achs la_schr wink laen typ_t ei_w work ei_t ei_ efp_t efp_w efp_ profil_ profil profil2 schr_stil schr_mst color_prof color_unsi color_achs color_schr lttyp_prof lttyp_unsi lttyp_achs lttyp_schr file init einh txt dfile lfile efptho0 efptho1 efptho2 dia du inifile)

  (if
    (findfile "hoprofil.ini")
    (progn
      (setq inifile
        (open
          (findfile "hoprofil.ini") "r"
        )
      )
      (setq ei_
        (read-line inifile)
      )
      (setq efp_
        (read-line inifile)
      )
      (setq achs 
        (read-line inifile)
      )
      (setq schr 
        (read-line inifile)
      )
      (setq schr_stil 
        (read-line inifile)
      )
      (setq schr_mst 
        (read-line inifile)
      )
      (setq profil_ 
        (read-line inifile)
      )
      (setq typ_ 
        (read-line inifile)
      )
      (setq darst 
        (read-line inifile)
      )
      (setq entity 
        (read-line inifile)
      )
      (close inifile)
    )
    (progn
      (alert "INI-Datei befindet sich nicht im Support-Pfad!")
    )
  )
  (if 
    (not init)
    (if 
      (setq file 
        (findfile "Einheit.ini")
      )
      (load file)
      (progn 
        (alert 
          (nth 0 txt)
        ) 
        (exit)
      )
    )
  )
  (setq dfile "Hoprofil.ger")
  (if 
    (setq file 
      (findfile dfile)
    )
    (progn
      (prompt 
        (strcat "\nLade " dfile ".")
      )
      (load dfile)
      (prompt "ok.")
    )
  )
  (prompt 
    (strcat "\nHoprofil " rel)
  )
  (error_s 
    (list "angdir" "blipmode" "cmdecho" "osmode" "thickness" "clayer" "hpname" "hpscale")
  )
  (if 
    (not 
      (setq file 
        (findfile "Hoprofil.dat")
      )
    )
    (progn 
      (alert 
        (nth 1 txt)
      ) 
      (exit)
    )
  )
  (ahm_f:Hoprofil_dcl)
  (if work 
    (ahm_f:Hoprofil_work Profil)
  )
  (if 
    (findfile "hoprofil.ini")
    (progn
      (setq inifile 
        (open 
          (findfile "hoprofil.ini") "w"
        )
      )
      (write-line ei_ inifile)
      (write-line efp_ inifile)
      (write-line achs inifile)
      (write-line schr inifile)
      (write-line schr_stil inifile)
      (write-line schr_mst inifile)
      (write-line profil_ inifile)
      (write-line typ_ inifile)
      (write-line darst inifile)
      (write-line entity inifile)
      (close inifile)
    )
    (progn
      (alert "INI-Datei befindet sich nicht im Support-Pfad!")
    )
  )
  (error_r)
  (princ)
)
(defun ahm_f:Hoprofil_dcl (/ line fr du ldiag done lae char word liste)
  (if 
    (not 
      (setq lfile 
        (findfile "Hoprofil.dcl")
      )
    )
    (alert 
      (strcat 
        (nth 2 txt)
      )
    )
  )
  (if 
    (not la_prof)
    (progn 
      (setq la_prof "Profil")
      (setq color_prof "7")
      (setq lttyp_prof "continuous")
      (command "layer" "m" la_prof "fa" color_prof "" "L" lttyp_prof la_prof "")
    )
  )
  (if 
    (not la_unsi)
    (progn 
      (setq la_unsi "Profil_Unsicht")
      (setq color_unsi "6")
      (setq lttyp_unsi "verdeckt")
      (command "layer" "m" la_unsi "fa" color_unsi "" "L" lttyp_unsi la_unsi "")
    )
  )
  (if 
    (not la_achs)
    (progn 
      (setq la_achs "Profil_Achsen")
      (setq color_achs "4")
      (setq lttyp_achs "mitte")
      (command "layer" "m" la_achs "fa" color_achs "" "L" lttyp_achs la_achs "")
    )
  )
  (if 
    (not la_schr)
    (progn 
      (setq la_schr "Profil_Schraff")
      (setq color_schr "1")
      (setq lttyp_schr "continuous")
      (command "layer" "m" la_schr "fa" color_schr "" "L" lttyp_schr la_schr "")
    )
  )
  (if 
    (not entity)
    (setq entity "0")
  )
  (if 
    (not darst)
    (setq darst "vorne")
  )
  (if 
    (not achs)
    (setq achs "0")
  )
  (if 
    (not schr)
    (setq schr "0")
  )
  (if 
    (not blk)
    (setq blk "1")
  )
  (if 
    (not schr_stil)
    (setq schr_stil "ansi31")
  )
  (if 
    (not schr_mst)
    (setq schr_mst "1.5")
  )
  (setq  fr 
    (open file "r") typ_f nil typ_t nil
  )
  (while 
    (setq line 
      (read-line fr)
    )
    (setq typ_f 
      (cons 
        (substr line 1 12) typ_f
      ) typ_t 
      (cons 
        (substr line 13) typ_t
      )
    )
  )
  (close fr)
  (setq typ_f 
    (reverse typ_f) typ_t 
    (reverse typ_t)
  )
  (if 
    (not typ_)
    (setq typ_ "0")
  )
  (setq ei_t nil ei_w nil)
  (foreach du einh
    (setq ei_t 
      (cons 
        (car du) ei_t
      ) ei_w 
      (cons 
        (caddr du) ei_w
      )
    )
  )
  (setq ei_t 
    (reverse ei_t) ei_w 
    (reverse ei_w)
  )
  (defun pr_dcl_einfuegho 
    (/ du da)
    (setq efp_t nil efp_w nil)
    (cond
      (
        (= darst "vorne") 
        (setq da efptho0)
      )
      (
        (= darst "seite") 
        (setq da efptho1)
      )
      (
        (= darst "drauf") 
        (setq da efptho2)
      )
      ('T 
        (setq da "T")
      )
    )
    (foreach du da
      (setq efp_t 
        (cons 
          (car du) efp_t
        ) efp_w 
        (cons 
          (cadr du) efp_w
        )
      )
    )
    (setq efp_t 
      (reverse efp_t) efp_w 
      (reverse efp_w)
    )
    (if 
      (not efp_)
      (setq efp_ "0")
    )
    (start_list "einfpktho")
    (mapcar 'add_list efp_t)
    (end_list)
    (set_tile "einfpktho" efp_)
  )
  (setq ld "Hoprofil_ger")
  (setq ldiag 
    (load_dialog lfile)
  )
  (if ldiag
    (if 
      (not 
        (new_dialog ld ldiag)
      )
      (exit)
    )
    (exit)
  )
  (start_list "typ")
  (mapcar 'add_list typ_t)
  (end_list)
  (set_tile "typ" typ_)
  (pr_dcl_typ typ_)
  (start_list "einheit")
  (mapcar 'add_list ei_t)
  (end_list)
  (if 
    (not ei_)
    (cond
      (
        (= ahm_v:emst 0.001) 
        (setq ei_ "0")
      )
      (
        (= ahm_v:emst 0.01) 
        (setq ei_ "1")
      )
      (
        (= ahm_v:emst 1.0) 
        (setq ei_ "2")
      )
      ('T 
        (setq ei_ "0")
      )
    )
  )
  (set_tile "einheit" ei_)
  (set_tile "entity" entity)
  (set_tile "darst" darst)
  (set_tile "schraffstil" schr_stil)
  (set_tile "schraffmst" schr_mst)
  (set_tile "achsen" achs)
  (set_tile "schraff" schr)
  (set_tile "block" blk)
  (pr_dcl_diaho)
  (pr_dcl_einfuegho)
  (action_tile "einheit" "(setq ei_ $VALUE)")
  (action_tile "einfpktho" "(setq efp_ $VALUE)")
  (action_tile "entity" "(pr_dcl_entityho $VALUE)")
  (action_tile "darst" "(pr_dcl_darstho $VALUE)")
  (action_tile "achsen" "(setq achs $VALUE)")
  (action_tile "schraff" "(pr_dcl_schrho $VALUE)")
  (action_tile "block" "(setq blk $VALUE)")
  (action_tile "typ" "(pr_dcl_typ $VALUE)")
  (action_tile "Profile" "(setq Profil_ $VALUE)")
  (action_tile "schraffstil" "(setq schr_stil $VALUE)")
  (action_tile "schraffmst" "(setq schr_mst $VALUE)")
  (action_tile "chancel" "(done_dialog 0)")
  (action_tile "accept" "(done_dialog 1)")
  (setq done 
    (start_dialog)
  )
  (unload_dialog ldiag)
  (cond
    (
      (= done 1)
      (setq ei_t 
        (strcase 
          (nth 
            (atoi ei_) ei_t
          ) nil
        ) ei_w 
        (nth 
          (atoi ei_) ei_w
        )efp_t 
        (strcase 
          (nth 
            (atoi efp_) efp_t
          ) nil
        )efp_w 
        (nth 
          (atoi efp_) efp_w
        )Profil 
        (nth 
          (atoi Profil_) Profil
        ) word:list nil schr_stil 
        (strcase schr_stil)
      )
      (setq lae 
        (strlen Profil) word "" liste nil
      )
      (repeat 
        (+ lae 1)
        (setq char 
          (substr Profil 1 1) Profil 
          (substr Profil 2)
        )
        (if 
          (and 
            (/= char " ") 
            (/= char "")
          )
          (setq word 
            (strcat word char)
          )
          (if 
            (/= word "")
            (setq liste 
              (cons word liste) word ""
            )
          )
        )
      )
      (setq Profil 
        (reverse liste) work T
      )
    )
    (
      (= done 0)
      (princ 
        (strcat "\n" 
          (nth 10 txt)
        )
      )
      (setq work nil)
    )
  )
  (princ)
)
(defun pr_dcl_typ (wert / file fr du)
  (setq file 
    (findfile 
      (setq du 
        (nth 
          (atoi wert) typ_f
        )
      )
    )
  )
  (if 
    (not file)
    (progn
      (alert 
        (strcat "AHM_FEHLER: Kann " du " nicht finden.")
      )
      (set_tile "typ" typ_)
    )
    (progn
      (setq fr
        (open file "r") Profil2 nil
      )
      (while
        (setq line
          (read-line fr)
        )
        (setq line
          (substr line 1 15)
        )
        (setq lae
          (strlen line) word ""
        )
        (repeat
          (+ lae 1)
          (setq char
            (substr line 1 1) line 
            (substr line 2)
          )
          (if
            (and
              (/= char " ")
              (/= char "")
            )
            (progn
              (if
                (= char "_")
                (setq char ".")
              )
              (setq word
                (strcat word char)
              )
            )
          )
        )
        (setq line word)
        (setq Profil2
          (cons line Profil2)
        )
      )
      (setq Profil2
        (reverse Profil2)
      )
      (close fr)
      (setq fr 
        (open file "r") Profil nil
      )
      (setq dia 
        (substr du 10 3)
      )
      (pr_dcl_diaho)
      (while 
        (setq line 
          (read-line fr)
        )
        (setq Profil 
          (cons line Profil)
        )
      )
      (setq Profil 
        (reverse Profil) du 
        (- 
          (length Profil) 1
        )Profil_ 
        (if 
          (not Profil_) "0" Profil_
        ) Profil_ 
        (if 
          (> 
            (atoi Profil_) du
          )
          (itoa du) Profil_
        ) typ_ wert
      )
      (close fr)
      (start_list "Profile")
      (mapcar 'add_list Profil2)
      (end_list)
      (set_tile "Profile" Profil_)
    )
  )
)
(defun pr_dcl_diaho (/ x y dux)
  (cond
    (
      (= darst "vorne") 
      (setq dux "0")
    )
    (
      (= darst "seite") 
      (setq dux "1")
    )
    (
      (= darst "drauf") 
      (setq dux "2")
    )
    ('T 
      (setq dux "T")
    )
  )
  (setq x 
    (dimx_tile "slide") y 
    (dimy_tile "slide")
  )
  (start_image "slide")
  (fill_image 0 0 x y 0)
  (slide_image 0 0 x y 
    (strcat "Hoprofil(" dia dux ")")
  )
  (end_image)
)
(defun pr_dcl_schrho (wert)
  (if 
    (or 
      (or 
        (= darst "seite") 
        (= darst "drauf")
      ) 
      (and 
        (= entity "1") 
        (= darst "vorne")
      )
    )
    (set_tile "schraff" 
      (setq schr "0")
    )
  )
  (setq schr wert)
)
(defun pr_dcl_darstho (wert)
  (if 
    (or 
      (= wert "seite") 
      (= wert "drauf")
    )
    (progn
      (set_tile "entity" 
        (setq entity "0")
      )
      (set_tile "schraff" 
        (setq schr "0")
      )
    )
  )
  (if 
    (= entity "1")
    (progn
      (set_tile "darst" 
        (setq darst "vorne")
      )
      (set_tile "schraff" 
        (setq schr "0")
      )
    )
  )
  (setq darst wert)
  (pr_dcl_diaho)
  (pr_dcl_einfuegho)
)
(defun pr_dcl_entityho (wert)
  (if 
    (or 
      (= darst "drauf") 
      (= darst "seite")
    )
    (progn
      (set_tile "darst" 
        (setq darst "vorne")
      )
      (set_tile "schraff" 
        (setq schr "0")
      )
    )
  )
  (if 
    (= entity "1")
    (set_tile "darst" 
      (setq darst "vorne")
    )
  )
  (setq entity wert)
  (pr_dcl_diaho)
)
(defun pr_wink_vorne ()
  (if 
    (= entity "1")
    (progn
      (initget 32)
      (setq GP1 
        (getpoint "\n Startpunkt:")
      )
      (setq GP2 
        (getpoint "\n Endpunkt:" GP1)
      )
      (if 
        (wcmatch 
          (getvar "acadver") "*15*"
        )
        (command "_.ucs" "_zaxis" GP1 GP2)
        (command "_.ucs" "ac" GP1 GP2)
      )
    )
  )
  (setq wink 
    (getint "\n Einfgewinkel (Verdrehung) Eingeben <0>:")
  )
  (if 
    (= wink nil)
    (setq wink 0.0)
  )
  (if 
    (/= wink 0.0)
    (command "_.ucs" "_z" wink)
  )
)
(defun pr_wink (/ winkel)
  (initget 32)
  (setq GP1 
    (getpoint "\n Startpunkt:")
  )
  (setq GP2 
    (getpoint "\n Endpunkt:" GP1)
  )
  (setq winkel 
    (angle GP1 GP2)
  )
  (setq laen 
    (distance Gp1 Gp2)
  )
  (setq wink 
    (/ 
      (* winkel 180) pi
    )
  )
  (if 
    (/= wink 0.0)
    (command "_.ucs" "_z" wink)
  )
)
(defun pr_einfpkt_vorne  (opt ho br)
  (cond
    (
      (= efp_w "OL")
      (setq pts 
        (polar pts 
          (* 3 pih) 
          (/ ho 2.0)
        ) pts 
        (polar pts 0 
          (/ br 2.0)
        )
      )
    )
    (
      (= efp_w "ML") 
      (setq pts 
        (polar pts 0 
          (/ br 2.0)
        )
      )
    )
    (
      (= efp_w "UL")
      (setq pts 
        (polar pts pih 
          (/ ho 2.0)
        ) pts 
        (polar pts 0 
          (/ br 2.0)
        )
      )
    )
    (
      (= efp_w "OM")
      (setq pts 
        (polar pts 
          (* 3 pih) 
          (/ ho 2.0)
        )
      )
    )
    (
      (= efp_w "UM") 
      (setq pts 
        (polar pts pih 
          (/ ho 2.0)
        )
      )
    )
    (
      (= efp_w "OR")
      (setq pts 
        (polar pts 
          (* 3 pih) 
          (/ ho 2.0)
        ) pts 
        (polar pts pi 
          (/ br 2.0)
        )
      )
    )
    (
      (= efp_w "MR") 
      (setq pts 
        (polar pts pi 
          (/ br 2.0)
        )
      )
    )
    (
      (= efp_w "UR")
      (setq pts 
        (polar pts pih 
          (/ ho 2.0)
        ) pts 
        (polar pts pi 
          (/ br 2.0)
        )
      )
    )
    (
      (= efp_w "SW") 
      (setq pts pts)
    )
    ('T 
      (alert "UNGEULTIGE OPTION EINFUEGEPUNKT:\nSchwerpunkt wird als Vorgabe verwendet.")
    )
  )
)
(defun pr_einfpkt_seite  (opt ho)
  (cond
    (
      (= efp_w "OL")
      (setq pts 
        (polar pts 
          (* 3 pih) 
          (/ ho 2.0)
        )
      )
    )
    (
      (= efp_w "SW")
      (setq pts pts)
    )
    (
      (= efp_w "UL")
      (setq pts 
        (polar pts pih 
          (/ ho 2.0)
        )
      )
    )
    ('T 
      (alert "UNGEULTIGE OPTION EINFUEGEPUNKT:\nSchwerpunkt wird als Vorgabe verwendet.")
    )
  )
)
(defun pr_einfpkt_drauf  (opt br)
  (cond
    (
      (= efp_w "OL")
      (setq pts 
        (polar pts 
          (* 3 pih) 
          (/ br 2)
        )
      )
    )
    (
      (= efp_w "SW")
      (setq pts pts)
    )
    (
      (= efp_w "UL")
      (setq pts 
        (polar pts pih 
          (/ br 2)
        )
      )
    )
    ('T 
      (alert "UNGEULTIGE OPTION EINFUEGEPUNKT:\nSchwerpunkt wird als Vorgabe verwendet.")
    )
  )
)
(defun ahm_f:Hoprofil_work (wert / typ4 pih ho br tt du pts ptm ho1 br1 pt0 pt1 pt2 pt3pt4 pt5 pt6 pt7 pt8 pt9 pt10 pt11 pt12 pt00 pt01 pt02 pt03 pt04 pt05 pt06 pt07 pt08pt09 pt010 pt011 pt012 pta1 pta2 pta3 pta4 P100 P101 P102 P103 P104 P105 P106 P107 P108P109 du1 lastob lastob1 entity-listho lastobj lastobj1 Q ein_h)
  (cond 
    (
      (= ei_ "0")
      (setq ein_h 1)
    )
    (
      (= ei_ "1")
      (setq ein_h 0.1)
    )
    (
      (= ei_ "2")
      (setq ein_h 0.001)
    )
  )
  (if 
    (= darst "vorne")
    (pr_wink_vorne)
    (pr_wink)
  )
  (command "layer" "se" la_prof "")
  (setq typ4 
    (strcase 
      (substr 
        (setq typt 
          (car wert)
        ) 1 3
      )
    ) pih  
    (/ pi 2.0)
  )
  (setq entity-listho 
    (entlast)
  )
  (if 
    (= entity-listho nil)
    (progn
      (entmake 
        (list 
          (cons 0 "POINT")
          (cons 8 "0")
          (cons 10 
            (list 0 0 0)
          )
        )
      )
      (setq entity-listho 
        (entlast)
      )
      (entdel 
        (entlast)
      )
    )
  )
  (while 
    (not
      (setq pts 
        (getpoint 
          (strcat "\n" 
            (nth 9 txt) efp_t ": "
          )
        )
      )
    )
  )
  (setvar "angdir" 0)
  (setvar "cmdecho" 0)
  (setvar "osmode" 0)
  (setvar "blipmode" 0)
  (cond
    (
      (or 
        (= typ4 "HQU") 
        (= typ4 "HRE")
      )
      (setq ho 
        (* 
          (atof 
            (nth 1 wert)
          ) ei_w
        ) br 
        (* 
          (atof 
            (nth 2 wert)
          ) ei_w
        ) tt 
        (* 
          (atof 
            (nth 3 wert)
          ) ei_w
        )
      )
      (cond
        (
          (= darst "vorne")
          (pr_einfpkt_vorne pts ho br)
          (setq ho1 
            (- ho tt tt) br1   
            (- br tt tt) ptm pts pt0 
            (polar pts 0 
              (/ br 2.0)
            ) pt1 
            (polar pt0 pih 
              (/ ho1 2.0)
            ) pt2 
            (polar pt1 pih tt) pt3 
            (polar pt2 pi tt) pt4 
            (polar pt3 pi br1) pt5 
            (polar pt4 pi tt) pt6 
            (polar pt5 
              (* 3 pih) tt
            ) pt7 
            (polar pt6 
              (* 3 pih) ho1
            ) pt8 
            (polar pt7 
              (* 3 pih) tt
            ) pt9 
            (polar pt8 0 tt) pt10 
            (polar pt9 0 br1) pt11 
            (polar pt10 0 tt) pt12  
            (polar pt11 pih tt) ho1 
            (- ho1 tt tt) br1 
            (- br1 tt tt) pt00  
            (polar pts 0 
              (- 
                (/ br 2.0) tt
              )
            ) pt01 
            (polar pt00 pih 
              (/ ho1 2.0)
            ) pt02 
            (polar pt01 pih tt) pt03 
            (polar pt02 pi tt) pt04 
            (polar pt03 pi br1) pt05 
            (polar pt04 pi tt) pt06 
            (polar pt05 
              (* 3 pih) tt
            ) pt07 
            (polar pt06 
              (* 3 pih) ho1
            ) pt08 
            (polar pt07 
              (* 3 pih) tt
            ) pt09 
            (polar pt08 0 tt) pt010 
            (polar pt09 0 br1) pt011 
            (polar pt010 0 tt) pt012 
            (polar pt011 pih tt) pta1 
            (polar pts pi 
              (+ 
                (* br 0.5)
                (* ein_h 5.0)
              )
            ) pta2 
            (polar pts 0 
              (+ 
                (* br 0.5)
                (* ein_h 5.0)
              )
            ) pta3 
            (polar pts pih 
              (+ 
                (* 0.5 ho)
                (* ein_h 5.0)
              )
            ) pta4 
            (polar pts 
              (* 3 pih) 
              (+ 
                (* 0.5 ho)
                (* ein_h 5.0)
              )
            )
          )
          (command "_.pline" pt12 pt1 "_arc" pt3 "_line" pt4 "_arc" pt6 "_line" pt7"_arc" pt9 "_line" pt10 "_arc" pt12 "_close")
          (setq lastob1 
            (entlast)
          )
          (command "_.pline" pt012 pt01 "_arc" pt03 "_line" pt04 "_arc" pt06 "_line"pt07 "_arc" pt09 "_line" pt010 "_arc" pt012 "_close")
        )
        (
          (= darst "seite")
          (pr_einfpkt_seite pts ho)
          (setq ptm pts P100 
            (polar pts 
              (* 3 pih) 
              (/ ho 2)
            ) P101 
            (polar p100 0 laen) P103 
            (polar p101 pih tt) P105 
            (polar p101 pih 
              (/ ho 2)
            ) P109 
            (polar p101 pih ho) P107 
            (polar p109 
              (* pih 3.0) tt
            ) P102 
            (polar p100 pih tt) P104 
            (polar p100 pih 
              (/ ho 2)
            ) P108 
            (polar p100 pih ho) P106 
            (polar p108 
              (* pih 3.0) tt
            )
          )
          (command "Plinie" P100 P101 P109 P108 "s")
          (command "_.layer" "se" la_unsi "")
          (command "Linie" P102 P103 "")
          (command "Linie" P106 P107 "")
          (if 
            (= achs "1")
            (command "_.layer" "se" la_achs "" "Linie" P104 P105 "")
          )
        )
        (
          (= darst "drauf")
          (pr_einfpkt_drauf pts br)
          (setq ptm pts P100 
            (polar pts 
              (* 3 pih) 
              (/ br 2)
            ) P101 
            (polar p100 0 laen) P103 
            (polar p101 pih tt) P105 
            (polar p101 pih 
              (/ br 2)
            ) P109 
            (polar p101 pih br) P107 
            (polar p109 
              (* pih 3.0) tt
            ) P102 
            (polar p100 pih tt) P104 
            (polar p100 pih 
              (/ br 2)
            ) P108 
            (polar p100 pih br) P106 
            (polar p108 
              (* pih 3.0) tt
            )
          )
          (command "Plinie" P100 P101 P109 P108 "s")
          (command "_.layer" "se" la_unsi "")
          (command "Linie" P102 P103 "")
          (command "Linie" P106 P107 "")
          (if 
            (= achs "1")
            (command "_.layer" "se" la_achs "" "Linie" P104 P105 "")
          )
        )
      )
    )
    (
      (= typ4 "HRU")
      (setq du 
        (* 
          (atof 
            (nth 1 wert)
          ) ei_w
        ) tt 
        (* 
          (atof 
            (nth 2 wert)
          ) ei_w
        )
      )
      (cond
        (
          (= darst "vorne")
          (pr_einfpkt_vorne pts du du)
          (setq du1  
            (- du tt tt) pta1 
            (polar pts pi 
              (+ 
                (* du 0.5)
                (* ein_h 5.0)

              )
            ) pta2 
            (polar pts 0 
              (+ 
                (* du 0.5)
                (* ein_h 5.0)
              )
            ) pta3 
            (polar pts pih 
              (+ 
                (* 0.5 du)
                (* ein_h 5.0)
              )
            ) pta4 
            (polar pts 
              (* 3 pih) 
              (+ 
                (* 0.5 du)
                (* ein_h 5.0)
              )
            )
          )
          (command "_.circle" pts "_d" du)
          (setq lastob1 
            (entlast)
          )
          (command "_.circle" pts "_d" du1)
        )
        (
          (= darst "seite")
          (pr_einfpkt_seite pts du)
          (setq ptm pts P100 
            (polar pts 
              (* 3 pih) 
              (/ du 2)
            ) P101 
            (polar p100 0 laen) P103 
            (polar p101 pih tt) P105 
            (polar p101 pih 
              (/ du 2)
            ) P109 
            (polar p101 pih du) P107 
            (polar p109 
              (* pih 3.0) tt
            ) P102 
            (polar p100 pih tt) P104 
            (polar p100 pih 
              (/ du 2)
            ) P108 
            (polar p100 pih du) P106 
            (polar p108 
              (* pih 3.0) tt
            )
          )
          (command "Plinie" P100 P101 P109 P108 "s")
          (command "_.layer" "se" la_unsi "")
          (command "Linie" P102 P103 "")
          (command "Linie" P106 P107 "")
          (if 
            (= achs "1")
            (command "_.layer" "se" la_achs "" "Linie" P104 P105 "")
          )
        )
        (
          (= darst "drauf")
          (pr_einfpkt_drauf pts du)
          (setq ptm pts P100 
            (polar pts 
              (* 3 pih) 
              (/ du 2)
            ) P101 
            (polar p100 0 laen) P103 
            (polar p101 pih tt) P105 
            (polar p101 pih 
              (/ du 2)
            ) P109 
            (polar p101 pih du) P107 
            (polar p109 
              (* pih 3.0) tt
            ) P102 
            (polar p100 pih tt) P104 
            (polar p100 pih 
              (/ du 2)
            ) P108 
            (polar p100 pih du) P106 
            (polar p108 
              (* pih 3.0) tt
            )
          )
          (command "Plinie" P100 P101 P109 P108 "s")
          (command "_.layer" "se" la_unsi "")
          (command "Linie" P102 P103 "")
          (command "Linie" P106 P107 "")
          (if 
            (= achs "1")
            (command "_.layer" "se" la_achs "" "Linie" P104 P105 "")
          )
        )
      )
    )
  )
  (setq lastob 
    (entlast)
  )
  (if 
    (and 
      (= schr "1")
      (/= entity "1")
    )
    (progn
      (command "_.layer" "se" la_schr "")
      (command "_.hatch" schr_stil schr_mst "" lastob lastob1 "")
      (prompt 
        (strcat "\n" 
          (nth 3 txt)
        )
      )
    )
  )
  (command "_.layer" "se" la_prof "")
  (if 
    (= entity "1")
    (progn 
      (setq laen 
        (distance GP1 GP2)
      )
      (setvar "thickness" laen)
      (command "_.extrude" lastob "" laen "")
      (setq lastobj 
        (entlast)
      )
      (command "_.extrude" lastob1 "" laen "")
      (setq lastobj1 
        (entlast)
      )
      (command "_subtract" lastobj1 "" lastobj "")
      (prompt 
        (strcat "\n" typt " " 
          (nth 4 txt)
        )
      )
    )
  )
  (if 
    (and 
      (= darst "vorne") 
      (= achs "1")
    )
    (progn
      (setvar "thickness" 0)
      (command "_.layer" "se" la_achs "")
      (setq asatz 
        (ssadd)
      )
      (command "_.line" pta1 pta2 "")
      (setq asatz 
        (ssadd 
          (entlast) asatz
        )
      )
      (command "_.line" pta3 pta4 "")
      (setq asatz 
        (ssadd 
          (entlast) asatz
        )
      )
      (if 
        (= entity "1")
        (command "._copy" asatz "" "@0,0,0" 
          (strcat "@0,0," 
            (rtos laen 2)
          )
        )
      )
      (setq asatz nil)
    )
  )
  (if 
    (= blk "1")
    (progn
      (command "_.layer" "se" la_prof "")
      (setq du entity-listho entity-listho 
        (ssadd)
      )
      (while 
        (setq du 
          (entnext du)
        )
        (ssadd du entity-listho)
      )
      (if 
        (and 
          (/= gp1 nil)
          (/= gp2 nil)
        )
        (setq blname 
          (strcat "AHM-" 
            (strcase typt) "-" darst "_" 
            (rtos 
              (* 
                (distance gp1 gp2) 1000
              ) 2 0
            )
          )
        )
        (setq blname 
          (strcat "AHM-" 
            (strcase typt) "-" darst "_0"
          )
        )
      )
      (if 
        (tblsearch "block" blname)
        (progn
          (command "_.block" blname "_y" pts entity-listho "")
          (prompt 
            (strcat "\nBlock " blname " " 
              (nth 5 txt)
            )
          )
        )
        (progn
          (command "_.block" blname pts entity-listho "")
          (prompt 
            (strcat "\n" typt " " 
              (nth 6 txt) blname " " 
              (nth 7 txt)
            )
          )
        )
      )
      (command "_.insert" blname pts "" "" "")
    )
  )
)
(defun error (msg)
  (if 
    (/= msg "Function cancelled")
    (prompt 
      (strcat "\nAHM_Fehler:  " msg)
    )
    (prompt 
      (strcat "\nAHM_Fehler:  " 
        (nth 8 txt)
      )
    )
  )
  (setq *error* ahm_v:oerror)
  (error_r)
  (princ)
)
(defun error_s (liste)
  (setq ahm_v:oerrl nil ahm_v:olay 
    (getvar "clayer") ocmd 
    (getvar "cmdecho")
  )
  (setvar "cmdecho" 0)
  (command "_.undo" "_be")
  (if 
    (tblsearch "UCS" "AHM_UCS")
    (command "_.ucs" "_del" "ahm_ucs")
  )
  (command "_.ucs" "_save" "ahm_ucs")
  (repeat 
    (length liste)
    (setq du 
      (car liste) ahm_v:oerrl 
      (cons 
        (list du 
          (getvar du)
        ) ahm_v:oerrl
      ) liste 
      (cdr liste)
    )
  )
  (setq ahm_v:oerror *error* *error* error)
)
(defun error_r (/ lis var val)
  (setvar "clayer" ahm_v:olay)
  (repeat 
    (length ahm_v:oerrl)
    (setq lis 
      (car ahm_v:oerrl) var 
      (car lis) val 
      (cadr lis) ahm_v:oerrl 
      (cdr ahm_v:oerrl)
    )
    (setvar var val)
  )
  (setq *error* ahm_v:oerror)
  (setvar "cmdecho" 0)
  (command "_.ucs" "_restore" "ahm_ucs")
  (command "_.ucs" "_del" "ahm_ucs")
  (command "_.undo" "_e")
  (setvar "cmdecho" ocmd)
  (princ)
)
(princ 
  (strcat "\n" "HOPROFIL.lsp geladen. Aufrufen mit HOPROFIL !" "  " rel)
)
(princ)
