;  Mit dem Programm Poszahl.lsp knnen Positionszahlen mit Fhrungslinie
;  in eine Zeichnung eingefgt werden.
;
;  Programmiert von:  Karl Maurer (C) 1996
;
;*************************************************************************

(defun c:posz1 ( / stpkt endp pnr th wi pt pt2 pt3 aw bw cw dw ew fw gw)

(setq cm (getvar "cmdecho"))
(setq bl (getvar "blipmode"))
(setq os (getvar "osmode"))
(setq alay (getvar "clayer"))

(setvar "cmdecho" 0)
(setvar "blipmode" 0)
(setvar "osmode" 0)

;************************* Programmbeginn *************************

(command "STIL" "POSZ" "isocp.shx" 0 "" "" "" "" )

(setq stpkt (getpoint "\n Startpunkt Linie:"))
  
  (while (/= stpkt nil)
(setq endp (getpoint stpkt "\n Endpunkt Linie:"))
  
  (command "Layer" "M" "posl" "FA" "1" "" "Lt" "" "posl" ""
           "Ring" 0 1.0 stpkt "" 
           "Linie" stpkt endp "")

(setq pnr (getstring T "\n Positionsnummer:"))

  (while (or (= pnr nil) (= pnr ""))
             (setq pnr (getstring T "\n Positionsnummer:"))
  );end while
  
  (initget "5")
(setq th (getreal "\n Texthoehe <5>: "))

    (if (= th nil)
        (setq th 5)
    )

(setq wi (angle stpkt endp ) 
       pt (polar endp wi 2)
        aw (* pi 0.75)
         bw (* pi 1.25)
          cw (* pi 1.5)
           dw (* pi 1.75)
            ew (* pi 1.76)
             fw (* pi 2)
              gw (/ pi 4))
    
  (command "Layer" "M" "posz" "FA" "3" "" "Lt" "" "posz" "")
  
  (cond    
      ((and (<= wi aw) (>= wi gw))
            (command "text" "z" pt th 0 pnr))
      
      ((and (> wi aw) (< wi bw))
             (setq pt2 (polar pt cw (/ th 2)))
              (command "text" "r" pt2 th 0 pnr))
      
      ((and (> wi ew) (<= wi fw))
             (setq pt2 (polar pt cw (/ th 2)))
              (command "text" pt2 th 0 pnr))
      
      ((< wi gw) 
        (setq pt3 (polar pt cw (/ th 2)))
         (command "text" pt3 th 0 pnr))
      
      ((and (>= wi bw) (<= wi dw))
             (setq pt4 (polar pt cw th))
              (command "text" "z" pt4 th 0 pnr))
  );end cond

(setq stpkt (getpoint "\n Startpunkt Linie :"))

);end while    

  (altsav)
 (princ)
);end defun

(princ)
(Prompt "\n Programm Poszahl geladen. Mit Eingabe -POSZ1- und RETURN starten")

(defun *error* (emsg)
(princ emsg)
(altsv)
(princ)
)

(defun altsv ()
(command "layer" "SE" alay "")
(setvar "blipmode" bl)
(setvar "osmode" os)
(setvar "cmdecho" cm)
)
(princ)
